#TEMPLATE(Rules,'Rules Templates'),FAMILY('ABC')
#!--------------------------------------------------------------------------
#!
#! All Rights Reserved World Wide
#! 
#!-  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
#EXTENSION(ExternalRulesG,'Global External Business Rules Manager'),APPLICATION(GlobalBusinessRulesManager)
#SHEET
#Display
#Display
#PROMPT('Error-indicator Image',OPENDIALOG('Select error-indicator image file','Icons (*.ico)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalErrorIndicatorImage,DEFAULT('BRuleNo.ico')
#PROMPT('Default Distance from Right:',SPIN(@n3,0,999)),%GlobalRuleOffSetRight,REQ,DEFAULT(3)                                                                                                                                               
#PROMPT('Name:',@s255),%RuleBaseName,REQ,Default('MyGlobalRules')
#PROMPT('Description:',@s255),%RuleBaseDescription,REQ
#PROMPT('Mode:',OPTION),%GlobalRulesTemplateMode,AT(4,,192)
#PROMPT('Original',RADIO)
#PROMPT('Clone',RADIO)
#PROMPT('Header Icon:',OPENDIALOG('Select Header Icon File','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesHeaderIcon,REQ,DEFAULT('BRules.ico')
#PROMPT('Valid Rule Icon:',OPENDIALOG('Select an Icon for a Valid Rule','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesValidRuleIcon,REQ,DEFAULT('BRuleOk.ico')
#PROMPT('Broken Rule Icon:',OPENDIALOG('Select an Icon for a Broken Rule','Icons (*.ICO)|*.ICO|Windows Bitmaps (*.bmp)|*.BMP|GIF files|*.gif|JPEG files (*.jpg)|*.JPG|Windows Metafiles (*.wmf)|*:WMF|PCX files|*.PCX|All files|*.*')),%GlobalViewRulesBrokenRuleIcon,REQ,DEFAULT('BRuleNo.ico')
#ENDSHEET

#AT(%AfterGlobalIncludes)
   INCLUDE('ABRULE.INC'),ONCE
#ENDAT

#AT(%GlobalData)
  #CASE(%ProgramExtension)
  #OF('DLL')
    #IF(%GlobalExternal)                              #!A DLL with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD
      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!A DLL with export global data
GlobalRule           LONG,THREAD
    #ENDIF
  #OF('LIB')
    #IF(%GlobalExternal)                              #!A LIB with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD
      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!A LIB with global data local
GlobalRule           LONG,THREAD
    #ENDIF
  #OF('EXE')
    #IF(%GlobalExternal)                              #!An EXE with global data external
      #IF(%ExternalSource='Dynamic Link Library (DLL)')
GlobalRule           LONG,EXTERNAL,DLL(dll_mode),THREAD
      #ELSE
GlobalRule           LONG,EXTERNAL,THREAD
      #ENDIF
    #ELSE                                             #!An EXE with global data local
GlobalRule           LONG,THREAD
    #ENDIF
  #ENDCASE
#ENDAT

#AT(%BeginningExports)
  #IF(NOT %GlobalExternal)
$GLOBALRULE                                             @?
  #ENDIF
#ENDAT


#EXTENSION(ExternalRules,'External Rules Local')
!*****************************************************************************
#SHEET
    #PROMPT('Check Rules After Open Window',Check),%LocalRuleCheckAfterOpenWindow,AT(10),DEFAULT(1)
    #PROMPT('Check Rules After Fields Change',Check),%LocalRuleCheckAfterFieldsChange,AT(10),DEFAULT(1)
    #PROMPT('Check Rules Before Updating Record',CHECK),%LocalRuleCheckBeforeUpdate,DEFAULT(1),AT(10)
#ENDSHEET

#AT(%CustomGlobalDeclarations)
  #IF(%GlobalErrorIndicatorImage)
      #PROJECT(%GlobalErrorIndicatorImage)
  #ENDIF
  #IF(%GlobalViewRulesHeaderIcon)
      #PROJECT(%GlobalViewRulesHeaderIcon)
  #ENDIF
  #IF(%GlobalViewRulesValidRuleIcon)
      #PROJECT(%GlobalViewRulesValidRuleIcon)
  #ENDIF
  #IF(%GlobalViewRulesBrokenRuleIcon)
      #PROJECT(%GlobalViewRulesBrokenRuleIcon)
  #ENDIF
#ENDAT

#AT(%LocalDataClassData)
BusinessRulesManager  RulesManager
%RuleBaseName         RulesCollection   !Business Rule Manager for %RuleBaseDescription

LocalWindowQueue         QUEUE,PRE(LWQ)
ControlUse                 STRING(20)
Control                    UNSIGNED
                         END
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(6500)
#Embed(%StartApplyingRules,'Start applying the Rules')
 #!#IF(Records(RulesQueue) > 1)
 BIND('Action',ThisWindow.Request)
 %RuleBaseName.SetErrorImage('~%GlobalErrorIndicatorImage')
 %RuleBaseName.SetDescription('%RuleBaseDescription')
 #!#EndIF
 #!Use ControlUse because that will leave of List boxes ect
 Free(LocalWindowQueue)
 #FOR(%Control)
    #IF(%ControlUse = '')
   LWQ:ControlUse = Upper(Sub('%control',2,Len('%control')))
    #Else
   LWQ:ControlUse = Upper('%ControlUse')
    #ENDIF
   LWQ:Control    = %Control
   Add(LocalWindowQueue,LWQ:ControlUse)
 #ENDFOR

#Embed(%BeforeApplyingRules,'Before applying the Rules')
  !Run through rules
  Loop I# = 1 to Records(RulesQueue)
     Get(RulesQueue,I#)
     If not error()
        !Check if rule's control is on screen
        LWQ:ControlUse = RQ:ControlUse
        Get(LocalWindowQueue,LWQ:ControlUse)
        If not error()
#Embed(%CheckProcBeforeApplyingRules,'Check Procedure Before applying the Rules')
           !If rule's control is on screen - add rule
           !Check if rule is not overridden on this procedure
           RPQ:Name     = Clip(RQ:Name)
           RPQ:ProcName = Upper('%Procedure')
           Get(RulesProcQueue,RPQ:Name,RPQ:ProcName)
           If error()
              %RuleBaseName.AddRule(Clip(RQ:Name),Clip(RQ:Description),Clip(RQ:Expression),LWQ:Control,RQ:Offset)
              !Check rule's rule-action-control
              RCQ:Name = RQ:Name
              Get(RulesControlQueue,RCQ:Name)
              If not error()
                 Position# = Pointer(RulesControlQueue) + 1
                 Loop
                    !If rule's rule-action-control is on window - add control to rule
                    LWQ:ControlUse = RCQ:ControlUse
                    Get(LocalWindowQueue,LWQ:ControlUse)
                    If not error()
                       %RuleBaseName.AddControlToRule(Clip(RCQ:Name),LWQ:Control,RCQ:RuleAction)
                    End
                    Get(RulesControlQueue,Position#)
                    If error() or RCQ:Name <> RQ:Name then break.
                    Position# += 1
                 End
              End
           End
        End
     End
  End
#Embed(%AfterApplyingRules,'After applying the Rules')
%RuleBaseName.SetEnumerateIcons('~%GlobalViewRulesHeaderIcon','~%GlobalViewRulesValidRuleIcon','~%GlobalViewRulesBrokenRuleIcon')
BusinessRulesManager.AddRulesCollection(%RuleBaseName)
BusinessRulesManager.SetEnumerateIcons('~%GlobalViewRulesHeaderIcon','~%GlobalViewRulesValidRuleIcon','~%GlobalViewRulesBrokenRuleIcon')
BusinessRulesManager.SetGlobalRuleReferences(GlobalRule)
#Embed(%FinishedApplyingRules,'Finished with applying the Rules')
#ENDAT

#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'),PRIORITY(9500)
#IF(%LocalRuleCheckAfterOpenWindow)
  #!#IF(ITEMS(%AUXLRules))
BusinessRulesManager.CheckAllRules(1)                    #<!Checking all Rules in RulesManager
  #!#ENDIF
#ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeNewSelection','(),BYTE'),PRIORITY(6900)
#IF(%LocalRuleCheckAfterFieldsChange)
  #!#IF(ITEMS(%AUXLRules))
  IF FIELD()
     UPDATE
     BusinessRulesManager.CheckAllRules(True)                 #<!Checking all Rules in RulesManager
     DISPLAY
  END
  #!#ENDIF
#ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeAccepted','(),BYTE'),PRIORITY(6400)
#IF(%LocalRuleCheckAfterFieldsChange)
  #!#IF(ITEMS(%AUXLRules))
  IF ACCEPTED()
     UPDATE
     BusinessRulesManager.CheckAllRules(True)                 #<!Checking all Rules in RulesManager
     DISPLAY
  END
  #!#ENDIF
#ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeAccepted','(),BYTE'),PRIORITY(2250)
#!#IF(ITEMS(%AUXLRules))
BusinessRulesManager.TakeAccepted(Accepted())                                                      #<!RulesManager traps to determine if error-indicator was clicked
#!#ENDIF
#ENDAT

#AT(%WindowManagerMethodCodeSection,'TakeCompleted'),PRIORITY(2800)
  #IF(%LocalRuleCheckBeforeUpdate=%True)
IF BusinessRulesManager.CheckAllRules(0)
  RETURN Level:Notify
END
  #ENDIF
#ENDAT
